<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml"
                template="/plantilla-principal.xhtml"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough"
                xmlns:jsf="http://xmlns.jcp.org/jsf"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:define name="contenido">
        <f:metadata>
            <f:event type="preRenderView" listener="#{sessionManBean.modulosFuncionalidad(2)}"></f:event>
        </f:metadata>
        <style>
            #div-btn-elim{
                display: none;
            }
            div.scroll{
                height: 600px;
                overflow: auto;
            }
        </style>
        <h1>Catgeoria Cliente</h1>
        <div class="ui stackable grid">
            <div class="ten wide column">
                <div class="ui secondary menu">
                    <div class="fitted item">
                        <div id="boton-nuevo" class="ui green button">
                            <i class="file icon" />
                            Nuevo
                        </div>
                    </div>
                    <div jsf:rendered="#{sessionManBean.permisosAsignados(6)}" id="div-btn-elim" class="fitted item">
                        <div class="ui red button" onclick="limpiarFormulario()">
                            <i class="trash icon"/>
                            Eliminar
                        </div>
                    </div>
                </div>
                 <div class="ui fluid icon input search">
                    <input id="txtBuscar" placeholder="Buscar" type="text"></input>
                    <i class="search icon"></i>
                    </div>
                <div id="scroll" class="scroll">
                <h:form id="form-tabla">
                        <table jsf:id="elementos-tabla" class="ui selectable celled table">
                            <thead>
                                <tr><th class="collapsing">
                                        <div  class="ui fitted checkbox" onclick="seleccionarTodo()">
                                            <input type="checkbox" id="chk-selec-todo"/>
                                            <label/>
                                        </div>
                                    </th>
                                    <th>ID</th>
                                    <th>Categoria</th>
                                    <th>Porcentaje</th>
                                    <!--<th></th>-->
                                </tr>
                            </thead>
                            <tbody>

                                <ui:repeat value="#{categoriaManBean.categoria}" var="categoria" varStatus="categoriaBarStatus">
                                    <tr id="cat#{categoria.idcategoria}">
                                        <td onclick="seleccionarFila('#{categoria.idcategoria}')"> 
                                            <div onclick="seleccionarCheck(#{categoria.idcategoria})"  class="ui fitted checkbox">
                                                <input id="chk-cat-#{categoria.idcategoria}" type="checkbox" />
                                                <label></label>
                                            </div>
                                        </td>
                                        <td width="25px" id="col-id-categoria-#{categoria.idcategoria}" onclick="seleccionarFila('#{categoria.idcategoria}')">#{categoria.idcategoria}</td>
                                        <td id="col-nombre-#{categoria.idcategoria}" onclick="seleccionarFila('#{categoria.idcategoria}')">#{categoria.nombre}</td>
                                        <td width="35px" id="col-porcentaje-#{categoria.idcategoria}" onclick="seleccionarFila('#{categoria.idcategoria}')" >#{categoria.porcentajeDescuento}</td>
                                    </tr>
                                </ui:repeat>
                            </tbody>
                        </table>
                </h:form>
                </div>
            </div>
            <div class="six wide column">
                <h:form id="form-datos">
                    <div class="ui divider hidden"></div>
                    <div class="ui divider hidden"></div>
                    <div class="ui form">
                        <div class="field">
                            <label>ID</label>
                            <input disabled="true" jsf:id="idcategoria" name="iscategoria" jsf:value="#{categoriaManBean.categoriaVar.idcategoria}" placeholder="ID" type="number" readonly="true"></input>
                            <h:inputHidden id="idcat-hidden" value="#{categoriaManBean.categoriaVar.idcategoria}" />
                        </div>
                        <div id="catC" class="required field">
                            <label>Categoria</label>
                            <input jsf:id="nombreCategoria" name="nombreCategoria" jsf:value="#{categoriaManBean.categoriaVar.nombre}" placeholder="Categoria" type="text" autofocus="true"></input>
                        </div>
                        <div id="porcentajeCat" class="required field">
                            <label>Porcentaje Descuento</label>
                            <input jsf:id="porcentajeCategoria" name="porcentajeCategoria" jsf:value="#{categoriaManBean.categoriaVar.porcentajeDescuento}" placeholder="Porcentaje Descuento" type="text" onkeypress="if(event.keyCode===13){document.getElementById('form-datos:btn-agre').click();}"></input>
                        </div>
                    </div>
                    <div id="msg-formulario" class="ui info hidden message">
                        <i class="close icon" />
                        <div class="header">
                            Info
                        </div>
                        <h:outputText id="text-formulario" value="#{categoriaManBean.msg}"/>
                    </div>
                    <!--</div>-->
                    <p/>
                    <p/>
                    <div class="actions">
                        <h:commandLink rendered="#{sessionManBean.permisosAsignados(5)}" id="btn-modif" class="ui teal button" onclick="validarCampos()" action="#{categoriaManBean.editarCategoria()}">
                            <i class="save icon" />
                            Guardar
                            <f:ajax execute="@form" onevent="function (data) {
                            if (data.status == 'success') {
                            if ($('#msg-formulario').css('display') == 'none') {
                            $('#msg-formulario').transition('fade');
                            }
                            }
                            }" 
                            render="text-formulario form-tabla"/>
                        </h:commandLink>
                        <h:commandLink rendered="#{sessionManBean.permisosAsignados(4)}" id="btn-agre" class="ui primary button" onclick="validarCampos()" action="#{categoriaManBean.registrarCategoria()}">
                            <i class="add circle icon" />
                            Agregar
                            <f:ajax execute="@form" onevent="function (data) {
                            if (data.status == 'success') {
                            if ($('#msg-formulario').css('display') == 'none') {
                            $('#msg-formulario').transition('fade');
                            }
                            }
                            }" 
                            render="text-formulario form-tabla"/>
                        </h:commandLink>
                    </div>
                </h:form>
                
                <h:form rendered="#{sessionManBean.permisosAsignados(6)}" id="dlg-conf-elim" class="ui basic modal">
                    <input name="selbar" id="selbar" type="hidden" jsf:value="#{categoriaManBean.seleccionarCategoriIDJSON}"/>
            <div class="ui icon header">
                <i class="trash icon"></i>
                Eliminar categoria cliente
            </div>
            <div class="centered content">
                <p>¿Desea eliminar los elementos seleccionados?</p>
            </div>
            <div class="actions">
                <button jsf:action="#{categoriaManBean.eliminarCategoria()}" class="ui green ok inverted button">
                    <i class="checkmark icon"></i>
                    Sí
                    <f:ajax execute="@form" onevent="generarDatos()" render="form-tabla"/>
                </button>

                <div class="ui red basic cancel inverted button">
                    <i class="remove icon"></i>
                    No
                </div>
            </div>
        </h:form>
                
            </div>
        </div>
        <script>
            $('#form-datos\\:btn-modif').hide();
            $("#boton-nuevo").click(function (){
                $('#form-datos\\:btn-agre').show();
                $('#form-datos\\:btn-modif').hide();
                limpiarFormulario();
                removerCampoError();
            });
            
            $('#form-datos\\:btn-agre').click(function (){
                limpiarFormulario();
            });
            
            $('#form-datos\\:btn-modif').click(function  (){
                limpiarFormulario();
            });
            
            $('#div-btn-elim').click(function () {
                $('#dlg-conf-elim').modal('show');
            });
            
            $('.message .close').on('click', function () {
                $(this).closest('.message').transition('fade');
            });
            
            function comprobarSeleccionTodo(){
                var seleccionados = $('tbody :checkbox:checked').length;
                var cantfila = $("tbody tr").length;
                if(seleccionados === 0){
                    $("#chk-selec-todo").prop("checked", false);
                }else{
                    if(seleccionados===cantfila){
                        $("#chk-selec-todo").prop("checked", true);
                    }else{
                        $("#chk-selec-todo").prop("checked", false);
                    }
                }
            }
            
            function ocultarBtnEliminarAndModifcar(){
                var seleccionado =$("tbody :checkbox:checked").length;
                if (seleccionado > 0) {
                    $("#div-btn-elim").show();
                    if (seleccionado===1) {
                        $('#form-datos\\:btn-modif').show();
                        $('#form-datos\\:btn-agre').hide();
                    }else{
                       $('#form-datos\\:btn-modif').hide();
                       $('#form-datos\\:btn-agre').show();
                    }
                }else{
                    $('#form-datos\\:btn-modif').hide();
                    $("#div-btn-elim").hide();
                    $('#form-datos\\:btn-agre').show();
                    clearFormulario();
                }
            }
            
            function seleccionarTodo(){
                if ($("#chk-selec-todo").prop("checked")) {
                    $("tbody tr").addClass("active");
                    $("tbody :checkbox").prop("checked", true);
                    $('#form-datos\\:btn-modif').hide();
                } else{
                    $("tbody tr").removeClass("active");
                    $("tbody :checkbox").prop("checked", false);
                    limpiarFormulario();
                }
                ocultarBtnEliminarAndModifcar();
            }
            
            function seleccionarFila(idcat){
                var idfila = '#cat' + idcat;
                var idchk = '#chk-cat-' + idcat;
                if($(idfila).hasClass('active')){
                    $(idfila).removeClass('active');
                    $(idchk).prop('checked', false);
                    limpiarFormulario();
                }else {
                    $('#form-datos\\:nombreCategoria').focus();
                    $(idfila).addClass('active');
                    $(idchk).prop('checked', true);
                }
                ocultarBtnEliminarAndModifcar();
                comprobarSeleccionTodo();
                modificarCategoria(idcat);
                removerCampoError();
            }
            
            function seleccionarCheck(idcat){
                var idchk = "#chk-cat-" + idcat;
                var idfila = "cat" + idcat;
                if ($(idchk).prop("checked")) {
                    $(idfila).removeClass("active");
                    limpiarFormulario();
                } else{
                    $(idfila).addClass("active");
                    $('#form-datos\\:nombreCategoria').focus();
                }
                ocultarBtnEliminarAndModifcar();
                comprobarSeleccionTodo();
                modificarCategoria(idcat);
                removerCampoError();
            }
            
            function modificarCategoria(idcat){
                $('#form-datos\\:idcategoria').val($('#col-id-categoria-'+idcat).html());
                $('#form-datos\\:idcat-hidden').val($('#col-id-categoria-'+idcat).html());
                $('#form-datos\\:nombreCategoria').val($('#col-nombre-'+idcat).html());
                $('#form-datos\\:porcentajeCategoria').val($('#col-porcentaje-'+idcat).html());
            }
            
            function validarCampos(){
                var categoria = $("#form-datos\\:nombreCategoria").val();
                var porcentaje = $("#form-datos\\:porcentajeCategoria").val();
                if(categoria === ""){
                    $('#catC').addClass('error');
                }else {
                    $('#catC').removeClass('error');
                }
                if(porcentaje === ""){
                    $('#porcentajeCat').addClass('error');
                }else {
                    $('#porcentajeCat').removeClass('error');
                }
            }
            
            function removerCampoError(){
                $('#porcentajeCat').removeClass('error');
                $('#catC').removeClass('error');
            }
            
            function generarDatos(){
                var idSeleccionados=[];
                $("tbody tr [id^='col-id-categoria']").each(function (index, value){
                   var id = parseInt($(this).html());
                   
                   if($('#chk-cat-'+id).prop('checked')){
                       idSeleccionados.push(id);
                       limpiarFormulario();
                   }
                });
                var jsonselect = JSON.stringify(idSeleccionados);
                $('#selbar').val(jsonselect);
                $('#div-btn-elim').hide();
            }
            
            function limpiarFormulario(){
                $('#form-datos\\:idcategoria').val($().html());
                $('#form-datos\\:idcat-hidden').val($().html());
                $('#form-datos\\:nombreCategoria').val($().html());
                $('#form-datos\\:porcentajeCategoria').val($().html());
                $('#form-datos\\:nombreCategoria').focus();
            }
            
            function clearFormulario(){
                $('#form-datos\\:idcategoria').clear();
                $('#form-datos\\:idcat-hidden').clear();
                $('#form-datos\\:nombreCategoria').clear();
                $('#form-datos\\:porcentajeCategoria').clear();
                $('#form-datos\\:nombreCategoria').focus();
            }
            
            $(document).ready(function(){
                $("#txtBuscar").keyup(function(){
                    if( $(this).val() !== ""){
			$("#form-tabla\\:elementos-tabla tbody>tr").hide();
			$("#form-tabla\\:elementos-tabla td:contains-ci('" + $(this).val() + "')").parent("tr").show();
                    }else{
			$("#form-tabla\\:elementos-tabla tbody>tr").show();
                    }
                });
            });
            $.extend($.expr[":"],{
                "contains-ci": function(elem, i, match, array){
                    return (elem.textContent || elem.innerText || $(elem).text() || "").toLowerCase().indexOf((match[3] || "").toLowerCase()) >= 0;
                }
            });
        </script>
    </ui:define>
</ui:composition>